//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <list>
#include <algorithm>
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

//       ,
//    
class AddValue {
  private:
    int theValue;     // 
  public:
    //   
    AddValue(int v) : theValue(v) {}
    //   " "  
    void operator() (int& elem) const {
      elem += theValue;
    }
};

int main(int argc, char* argv[])
{
  list<int> coll;
  //      1  9
  for (int i=1; i<=9; ++i) {
    coll.push_back(i);
  }

  PRINT_ELEMENTS (coll,":\n");
  //     10
  for_each (coll.begin(),coll.end(), // 
    AddValue(10)); // 

  PRINT_ELEMENTS (coll,"  10:\n");

  //       
  for_each (coll.begin(), coll.end(),     //  AddValue
    AddValue(*coll.begin()) );     // 

  PRINT_ELEMENTS(coll,"   :\n");

  cout << endl;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
